#ifndef TSYNC_OBJECT_H
#define TSYNC_OBJECT_H

/////////////////////////////////////////////////////////////////////////////
//
// File: TsynObject.h
// Author: Kelvin Sung
// Date: April 2003
//
// 		TsyncObject: A class demonstrating some of the functionality of
// 		the MFC synchronization objects (CMutex and CEvent).
//
//

#include <iostream.h>

#include <afxmt.h>
		// for MFC Synchronization objects (CEvent/CMutex etc.)

#define kLastThread 5

class TsyncObject {
	private:

		int			fCommand;
		CMutex  	*fCommandMutex;
		CEvent		*fCommandReady;
		CEvent		*fCommandIsRead;
		
		void ChangeCommand(int id)	{
				fCommandMutex->Lock();
				fCommand = id;
				fCommandMutex->Unlock();
			}
				
	public:
		
		TsyncObject() :
				fCommand(-1)
			{
				fCommandMutex = new CMutex(); 				
				fCommandMutex->Unlock();					// initially command is _NOT_ locked

				fCommandReady = new CEvent(true,true); 		// initially assume command is  ready 
															// and manual reset
				fCommandIsRead = new CEvent(false,true); 	// initially command is not read
															// and manual reset

			}

		void SetCommand(int id)	{
				fCommandIsRead->ResetEvent();	
				
				fCommandReady->ResetEvent();
				ChangeCommand(id);
				fCommandReady->SetEvent();
			}

		void CommandIsRead() {
			fCommandIsRead->Lock();
		}

		bool Identified(int id) 	{
				bool found = false;
				fCommandReady->Lock();
				if (id == fCommand) {
					found = true;
					fCommandIsRead->SetEvent();
				} 
				return found;
			}

};

#endif
